#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "utils.h"

static GList *lista_nick;
static GList *lista_numeri;


void
on_text1_changed                       (GtkEditable     *editable,
                                        gpointer         user_data)
{

}


void
on_combo_entry1_changed                (GtkEditable     *editable,
                                        gpointer         user_data)
{

}


void
on_combo_entry2_changed                (GtkEditable     *editable,
                                        gpointer         user_data)
{
	gpointer nick;
	GtkWidget *number_widget;
	GList *scorro;
	number_widget = lookup_widget(GTK_WIDGET(editable), "entry2");

	nick = (gpointer ) gtk_editable_get_chars(GTK_EDITABLE(editable), 0, -1);

	scorro = g_list_find_custom(lista_nick, nick, find_string);
	
	gtk_entry_set_text(GTK_ENTRY(number_widget), g_list_nth_data(lista_numeri, g_list_position(lista_nick, scorro)));
}


void
on_entry2_changed                      (GtkEditable     *editable,
                                        gpointer         user_data)
{

}


void
on_entry3_changed                      (GtkEditable     *editable,
                                        gpointer         user_data)
{

}


void
on_combo_entry3_changed                (GtkEditable     *editable,
                                        gpointer         user_data)
{

}


void
on_button2_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget *number_widget;
	GtkWidget *script_widget;
	GtkWidget *from_widget;
	GtkWidget *text_widget;
	GnomeAppBar *app_bar;
	gchar *number;
	gchar *script;
	gchar *from;
	gchar *text;
	gchar *argv[10];
	gchar *buffer;
	
	script_widget = lookup_widget(GTK_WIDGET(button), "combo1");
	number_widget = lookup_widget(GTK_WIDGET(button), "entry2");
	from_widget   = lookup_widget(GTK_WIDGET(button), "entry3");
	text_widget   = lookup_widget(GTK_WIDGET(button), "text1");
	app_bar       = GNOME_APPBAR(lookup_widget(GTK_WIDGET(button), "appbar1"));
	
	script = gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(script_widget)->entry));
	number = gtk_entry_get_text(GTK_ENTRY(number_widget));
	from   = gtk_entry_get_text(GTK_ENTRY(from_widget));
	text   = gtk_editable_get_chars(GTK_EDITABLE(text_widget), 0, -1);
	control_text(text);
	gnome_appbar_clear_stack(app_bar);
	/*GTK_ENTRY_GET_TEXT non vuole il g_free!!*/
	
	/*TEST IF itaSMS IS READY TO WORK!*/
	argv[0] = g_strdup("sh");
	argv[1] = g_strdup("-c");
	argv[2] = g_strdup("itaSMS -v");
	argv[3] = NULL;
	
	buffer = exec_and_catch(argv);
	
	g_free(argv[2]);
	
	if(!strstr(buffer, "Version"))
	{
		g_warning("itaSMS is not in path!! install it!");
		gnome_appbar_push(app_bar, "itaSMS is not in path!! install it!");
	}
	else
	{
		g_free(buffer);
		
		argv[2] = g_strconcat("itaSMS ", number, " '", text, "' -S ", script, " -F", NULL);
		argv[3] = NULL;
		
		buffer = g_strdup(exec_and_catch(argv));
		
		if(!strlen(text)) gnome_appbar_push(app_bar, "Text is NULL!!");else
		if(!strlen(number)) gnome_appbar_push(app_bar, "Number is NULL!!");else
		{
			control_text(buffer);
			gnome_appbar_push(app_bar, buffer);
		}
		g_free(argv[2]);
	}
	g_free(buffer);
	g_free(argv[0]);
	g_free(argv[1]);
	if(text) g_free(text);	
}


void
on_button3_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_combo1_size_allocate                (GtkWidget       *widget,
                                        GtkAllocation   *allocation,
                                        gpointer         user_data)
{
	GList *lista_script = NULL;
		
	lista_script = findscript();
	
	gtk_combo_set_popdown_strings(GTK_COMBO(widget), lista_script);
	
	g_list_free(lista_script);
}
void
on_combo2_size_allocate                (GtkWidget       *widget,
                                        GtkAllocation   *allocation,
                                        gpointer         user_data)
{	
	lista_nick = lista_numeri = NULL;
	findnick(&lista_nick, &lista_numeri);

	gtk_combo_set_popdown_strings(GTK_COMBO(widget), lista_nick);
	
}


void
on_help_clicked                        (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget *about;
	about = create_about1();
	gtk_widget_show(about);
}

